//
//  NIMFirstViewController.m
//  NIM
//
//  Created by Ben Lawson on 1/1/13.
//  Copyright (c) 2013 Ben Lawson. All rights reserved.
//

#import "NIMFirstViewController.h"
#import <QuartzCore/QuartzCore.h>

@interface NIMFirstViewController ()

@end

@implementation NIMFirstViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // -- MAKE FORM --
    QRootElement *root = [[QRootElement alloc] init];
    
    self.root = root;
    root.title = @"Home";
    root.grouped = YES;
    
    
    //fixes grouped not working
    [self loadView];
    
    QSection *section1 = [[QSection alloc] init];
    section1.headerImage = @"Logo";
    //section1.headerImage.
    QTextElement *description = [[QTextElement alloc] initWithText:@"Welcome to the NextImage Direct app! You can now save money by registering for an MRI scan right from your iPhone, iPod Touch, or iPad. Simply tap the \"Search\" tab and select a location near you."];
    //description.color = [UIColor whiteColor];
    [description setBackgroundColor:[UIColor whiteColor]];
    [root addSection:section1];
    [section1 addElement:description];
    
    QSection *fb = [[QSection alloc] init];
    QWebElement *facebook = [[QWebElement alloc] initWithTitle:@"Facebook" url:@"https://www.facebook.com/NextImageDirect"];
    facebook.image = [UIImage imageNamed:@"Facebook"];
    [root addSection:fb];
    [fb addElement:facebook];
    
    QSection *tw = [[QSection alloc] init];
    QWebElement *twitter = [[QWebElement alloc] initWithTitle:@"Twitter" url:@"https://twitter.com/NextImageDirect"];
    twitter.image = [UIImage imageNamed:@"Twitter"];
    [root addSection:tw];
    [tw addElement:twitter];

    
    //set tab bar style
    UITabBar *tabBar = [self.tabBarController tabBar];
    if ([tabBar respondsToSelector:@selector(setBackgroundImage:)])
	{
		[tabBar setBackgroundImage:[UIImage imageNamed:@"tabbar"]];
        [tabBar setSelectionIndicatorImage:[UIImage imageNamed:@"tabbar-active"]];
        [[UINavigationBar appearance] setBackgroundImage:[UIImage imageNamed:@"navbar"] forBarMetrics:UIBarMetricsDefault];
		
	}
	else
	{
		// ios 4 code here
		self.tabBarController.tabBar.layer.contents = (id)[UIImage imageNamed:@"tabbar"].CGImage;
	}


    locationManager = [[CLLocationManager alloc] init];
    
    //ask for location permission (now done in first view)
    //locationManager.purpose = @"Location needed to calculate ZIP code.";
    
    //get user location
    locationManager.distanceFilter = kCLDistanceFilterNone; // whenever user moves
    locationManager.desiredAccuracy = kCLLocationAccuracyHundredMeters;
    //locationManager.purpose = @"Location needed to calculate ZIP code.";
    [locationManager startUpdatingLocation];

}
- (void)setQuickDialogTableView:(QuickDialogTableView *)aQuickDialogTableView {
    [super setQuickDialogTableView:aQuickDialogTableView];
    //appearance
    self.quickDialogTableView.backgroundView = nil;
    self.quickDialogTableView.backgroundColor = [UIColor colorWithRed:242/255.0f green:242/255.0f blue:242/255.0f alpha:1.0f];
    //self.quickDialogTableView.bounces = NO;
    self.quickDialogTableView.styleProvider = self;
    NSLog(@"setQuickDialogTableView");
}

-(void) cell:(UITableViewCell *)cell willAppearForElement:(QElement *)element atIndexPath:(NSIndexPath *)indexPath{
    /*cell.backgroundColor = [UIColor colorWithRed:0.9582 green:0.9104 blue:0.7991 alpha:1.0000];
     
     if ([element isKindOfClass:[QEntryElement class]] || [element isKindOfClass:[QButtonElement class]]){
     cell.textLabel.textColor = [UIColor colorWithRed:0.6033 green:0.2323 blue:0.0000 alpha:1.0000];
     }*/
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
