//
//  NIMPage3ViewController.m
//  NIM
//
//  Created by Ben Lawson on 7/1/13.
//  Copyright (c) 2013 Ben Lawson. All rights reserved.
//
#define kOFFSET_FOR_KEYBOARD 82.0

#import "NIMPage3ViewController.h"

@interface NIMPage3ViewController ()
- (BOOL) validateEmail: (NSString *) candidate;
@end

@implementation NIMPage3ViewController

@synthesize formData;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    //title block
    QRootElement *root = [[QRootElement alloc] init];
    self.root = root;
    root.title = @"Patient Info";
    root.grouped = YES;
    /*QSection *section = [[QSection alloc] init];
    QLabelElement *label = [[QLabelElement alloc] initWithTitle:@"Patient Information" Value:@""]; //Patient Information Title
    [root addSection:section];
    [section addElement:label];*/
    //[self loadView];
    //end title block
    
    NSLog(@"recieved formdata: %@", formData);
    
    QSection *centerInfoSection = [[QSection alloc] init];
    centerInfoSection.title = @"Appointment Details";
    QLabelElement *facility = [[QLabelElement alloc] initWithTitle:@"Requested Facility" Value:[NSString stringWithFormat:@"%@ (%@)", [formData objectAtIndex:8], [formData objectAtIndex:10]]];
    QLabelElement *price = [[QLabelElement alloc] initWithTitle:@"Discount Price" Value:[NSString stringWithFormat:@"%@", [formData objectAtIndex:9]]];
    QLabelElement *procedureTitle = [[QLabelElement alloc] initWithTitle:@"Procedure" Value:nil];
    QTextElement *procedureText = [[QTextElement alloc] initWithText:[NSString stringWithFormat: @"%@ %@ %@ Contrast - %@", [formData objectAtIndex:1],[formData objectAtIndex:2],[formData objectAtIndex:3], [formData objectAtIndex:7]]];
    [procedureText setBackgroundColor:[UIColor whiteColor]];
    [root addSection:centerInfoSection];
    [centerInfoSection addElement:facility];
    [centerInfoSection addElement:price];
    [centerInfoSection addElement:procedureTitle];
    [centerInfoSection addElement:procedureText];
    
    //enter patient name section
    QSection *namesection = [[QSection alloc] init];
    QEntryElement *firstname = [[QEntryElement alloc] initWithTitle:@"First Name" Value:nil Placeholder:@"First Name"];
    QEntryElement *lastname = [[QEntryElement alloc] initWithTitle:@"Last Name" Value:nil Placeholder:@"Last Name"];
        
    [root addSection:namesection];
    [namesection addElement:firstname];
    [namesection addElement:lastname];
    //end patient name section
    
    
    //enter patient address section - remember to improve the state picker
    QSection *addressSection = [[QSection alloc] init];
    QEntryElement *address = [[QEntryElement alloc] initWithTitle:@"Address" Value:nil Placeholder:@"Enter Address"];
    QEntryElement *city = [[QEntryElement alloc] initWithTitle:@"City" Value:nil Placeholder:@"City"];
    NSArray *states = [NSArray arrayWithObjects:@"Alabama", @"Alaska", @"Arizona", @"Arkansas", @"California", @"Colorado", @"Connecticut", @"Delaware", @"Florida", @"Georgia", @"Hawaii", @"Idaho", @"Illinois", @"Indiana", @"Iowa", @"Kansas", @"Kentucky", @"Louisiana", @"Maine", @"Maryland", @"Massachusetts", @"Michigan", @"Minnesota", @"Mississippi", @"Missouri", @"Montana", @"Nebraska", @"Nevada", @"New Hampshire", @"New Jersey", @"New Mexico", @"New York", @"North Carolina", @"North Dakota", @"Ohio", @"Oklahoma", @"Oregon", @"Pennsylvania", @"Rhode Island", @"South Carolina", @"South Dakota", @"Tennessee", @"Texas", @"Utah", @"Vermont", @"Virginia", @"Washington", @"West Virginia", @"Wisconsin", @"Wyoming", nil];
    NSArray *stateNumbers = [NSArray arrayWithObjects:@"30", @"49", @"8", @"21", @"1",@"10", @"45", @"47", @"51", @"33", @"32", @"50", @"5", @"24", @"27", @"19",@"15", @"28", @"22", @"34", @"48", @"43", @"26", @"18", @"25", @"20", @"4",@"14", @"6", @"35", @"46", @"11", @"37", @"41", @"12", @"31", @"16", @"3", @"38",@"44", @"42", @"13", @"29", @"17", @"7", @"36", @"40", @"2", @"39", @"23", @"29",nil];
    QRadioElement *state = [[QRadioElement alloc] initWithItems:states selected:4 title:@"State"];
    //QEntryElement *state = [[QEntryElement alloc] initWithTitle:@"State" Value:nil Placeholder:@"State"];
    //[section1 addElement:[[QRadioElement alloc] initWithItems:[NSArray arrayWithObjects:@"Football", @"Soccer", @"Formula 1", nil] selected:0 title:@"Sport"]];
    QEntryElement *zipcode = [[QEntryElement alloc] initWithTitle:@"Zip Code" Value:@"" Placeholder:@"Zip Code"];
    zipcode.keyboardType = UIKeyboardTypeNumberPad;
    [root addSection:addressSection];
    [addressSection addElement:address];
    [addressSection addElement:city];
    [addressSection addElement:state];
    [addressSection addElement:zipcode];
    //end patient address section
    
    
    //enter patient contact information
    QSection *contact = [[QSection alloc] init];
    //QDecimalElement *phone = [[QDecimalElement alloc] initWithTitle:@"Phone Number" Value:nil Placeholder:@"XXX-XXX-XXXX"];
    QEntryElement *phone = [[QEntryElement alloc] initWithTitle:@"Phone Number" Value:@"" Placeholder:@"XXX-XXX-XXXX"];
    phone.keyboardType = UIKeyboardTypeNumberPad;
    QEntryElement *email = [[QEntryElement alloc] initWithTitle:@"Email" Value:nil Placeholder:@"Email"];
    email.keyboardType = UIKeyboardTypeEmailAddress;
    //chaneg to date picker
    //QEntryElement *DOB = [[QDecimalElement alloc] initWithTitle:@"DOB" Value:nil Placeholder:@"DOB"];
    NSDateFormatter *format = [[NSDateFormatter alloc] init];
    [format setDateFormat:@"mm-dd-yyyy"];
    QDateTimeInlineElement *DOB = [[QDateTimeInlineElement alloc] initWithTitle:@"DOB" date:[format dateFromString:@"01-01-1970"] andMode:UIDatePickerModeDate];
    //DOB.dateValue = [format dateFromString:@"01-01-1970"];
    //QEntryElement *gender = [[QEntryElement alloc] initWithTitle:@"Gender" Value:nil Placeholder:@"Male/Female"];
    NSArray *component1 = @[@"Male", @"Female"];
    QPickerElement *gender = [[QPickerElement alloc] initWithTitle:@"Gender" items:@[component1] value:@"Male\t"];
    
    [root addSection:contact];
    [contact addElement:phone];
    [contact addElement:email];
    [contact addElement:DOB];
    [contact addElement:gender];
    //end patient contact information

    
    //enter prescreen questions
    QSection *prescreen1 = [[QSection alloc] init];
    prescreen1.title = @"Pre-Screen Questions";
    QTextElement *qPresc = [[QTextElement alloc] init];
    qPresc.text = @"Do you have your imaging prescription?";
    [qPresc setBackgroundColor:[UIColor whiteColor]];
    QBooleanElement *prescription = [[QBooleanElement alloc] initWithTitle:nil BoolValue:YES];
    prescription.onImage = [UIImage imageNamed:@"yesImg"];
    prescription.offImage = [UIImage imageNamed:@"noImg"];
    [root addSection:prescreen1];
    [prescreen1 addElement:qPresc];
    [prescreen1 addElement:prescription];
    
    QSection *prescreen2 = [[QSection alloc] init];
    QTextElement *qMetal = [[QTextElement alloc] init];
    qMetal.text = @"Do you have metal or implants in the body?";
    [qMetal setBackgroundColor:[UIColor whiteColor]];
    QBooleanElement *metal = [[QBooleanElement alloc] initWithTitle:nil BoolValue:NO];
    metal.onImage = [UIImage imageNamed:@"yesImg"];
    metal.offImage = [UIImage imageNamed:@"noImg"];
    [root addSection:prescreen2];
    [prescreen2 addElement:qMetal];
    [prescreen2 addElement:metal];
    
    QSection *prescreen3 = [[QSection alloc] init];
    QTextElement *qKidney = [[QTextElement alloc] init];
    qKidney.text = @"Do you have any kidney, liver, hypertension or diabetic conditions?";
    [qKidney setBackgroundColor:[UIColor whiteColor]];
    QBooleanElement *kidney = [[QBooleanElement alloc] initWithTitle:nil BoolValue:NO];
    kidney.onImage = [UIImage imageNamed:@"yesImg"];
    kidney.offImage = [UIImage imageNamed:@"noImg"];
    [root addSection:prescreen3];
    [prescreen3 addElement:qKidney];
    [prescreen3 addElement:kidney];
    
    QSection *prescreen4 = [[QSection alloc] init];
    QEntryElement *heightfeet = [[QEntryElement alloc] initWithTitle:@"Height (feet)" Value:@"" Placeholder:@"feet"];
    heightfeet.keyboardType = UIKeyboardTypeNumberPad;
    QEntryElement *heightinch = [[QEntryElement alloc] initWithTitle:@"Height (inches)" Value:@"" Placeholder:@"inches"];
    heightinch.keyboardType = UIKeyboardTypeNumberPad;
    QEntryElement *weight = [[QEntryElement alloc] initWithTitle:@"Weight (pounds)" Value:@"" Placeholder:@"pounds"];
    weight.keyboardType = UIKeyboardTypeDecimalPad;
    [root addSection:prescreen4];
    [prescreen4 addElement:heightfeet];
    [prescreen4 addElement:heightinch];
    [prescreen4 addElement:weight];
    //end prescreen questions
    
    
    //referring physician information
    QSection *phys = [[QSection alloc] init];
    phys.title = @"Referring Physician's Information";
    //QLabelElement *physinfo = [[QLabelElement alloc] initWithTitle:@"Referring Physician's Information" Value:@""];
    QEntryElement *physnamef = [[QEntryElement alloc] initWithTitle:@"Physician's First Name" Value:nil Placeholder:@""];
    QEntryElement *physnamel = [[QEntryElement alloc] initWithTitle:@"Physician's Last Name" Value:nil Placeholder:@""];
    QEntryElement *physphone = [[QEntryElement alloc] initWithTitle:@"Physician's Phone #" Value:nil Placeholder:@"XXX-XXX-XXXX"];
    physphone.keyboardType = UIKeyboardTypeNumberPad;
    QEntryElement *physfax = [[QEntryElement alloc] initWithTitle:@"Physician's Fax #" Value:@"" Placeholder:@"XXX-XXX-XXXX"];
    physfax.keyboardType = UIKeyboardTypeNumberPad;
    QEntryElement *referralid = [[QEntryElement alloc] initWithTitle:@"Referral ID" Value:@"" Placeholder:@""];
    //QTextElement *hear = [[QTextElement alloc] initWithText:@"How did you hear about us?"];
    [root addSection:phys];
    [phys addElement:physnamef];
    [phys addElement:physnamel];
    [phys addElement:physphone];
    [phys addElement:physfax];
    [phys addElement:referralid];
    
    QSection *phys2 = [[QSection alloc] init];
    QMultilineElement *hear = [QMultilineElement new];
    hear.title = @"How did you hear about us?";
    [root addSection:phys2];
    //[phys addElement:physinfo];
    [phys2 addElement:hear];
    //end referring physician information
    
    
    //agreement section
    QSection *tos = [[QSection alloc] init];
    tos.title = @"Terms of Service";
    //NSString *pathToBundle = [[NSBundle mainBundle] bundlePath];
    //NSURL *baseURL = [NSURL fileURLWithPath:pathToBundle];
    NSString *pathToFile = [[NSBundle mainBundle] pathForResource:@"tos" ofType:@"html"];
    NSString *htmlFileToDisplay = [[NSString alloc] initWithContentsOfFile:pathToFile encoding:NSUTF8StringEncoding error:nil];
    QWebElement *terms = [[QWebElement alloc] initWithTitle:@"NID Terms of Service" HTML:htmlFileToDisplay];
    QBooleanElement *agree = [[QBooleanElement alloc] initWithTitle:@"I Agree to the TOS" BoolValue:NO];
    agree.onImage = [UIImage imageNamed:@"yesImg"];
    agree.offImage = [UIImage imageNamed:@"noImg"];
    [root addSection:tos];
    [tos addElement:terms];
    [tos addElement:agree];
    //end the agreement section
    
    QSection *submit = [[QSection alloc] init];
    QButtonElement *button = [[QButtonElement alloc] initWithTitle:@"Reserve and Pay"];
	button.onSelected = ^{
        while ([formData count] > 11) {
            [formData removeLastObject];
        }
                NSMutableArray *errors = [[NSMutableArray alloc] init];
        if ([firstname.textValue length] == 0) {
            [errors addObject:@"First Name is blank"];
        }
        if ([lastname.textValue length] == 0) {
            [errors addObject:@"Last Name is blank"];
        }
        if ([address.textValue length] == 0) {
            [errors addObject:@"Address is blank"];
        }
        if ([city.textValue length] == 0) {
            [errors addObject:@"City is blank"];
        }
        if ([zipcode.textValue length] == 0) {
            [errors addObject:@"Last Name is blank"];
        }
        if ([phone.textValue length] != 10) {
            [errors addObject:@"Patient's Phone # is not the correct length"];
        }
        if ([email.textValue length] == 0) {
            [errors addObject:@"Email is blank"];
        }
        if ([self validateEmail:email.textValue] == FALSE) {
            [errors addObject:@"Email is not valid"];
        }
        if ([heightfeet.textValue length] == 0) {
            [errors addObject:@"Height(feet) is blank"];
        }
        if ([heightinch.textValue length] == 0) {
            [errors addObject:@"Height(inch) is blank"];
        }
        if ([weight.textValue length] == 0) {
            [errors addObject:@"Weight is blank"];
        }
        if ([physnamef.textValue length] == 0) {
            [errors addObject:@"Phys's First Name is blank"];
        }
        if ([physnamel.textValue length] == 0) {
            [errors addObject:@"Phys's Last Name is blank"];
        }
        if ([physphone.textValue length] != 10) {
            [errors addObject:@"Phys's Phone # is not the correct length"];
        }
        if ([physphone.textValue length] != 10) {
            [errors addObject:@"Phys's Fax # is not the correct length"];
        }
        if (agree.boolValue == FALSE) {
            [errors addObject:@"Must agree to TOS"];
        }

        
        if ([errors count] > 0) {
            //alert
            NSMutableString *alertMessage = [[NSMutableString alloc] initWithString:@""];
            NSUInteger count = [errors count];
            for (NSUInteger i = 0; i < count; i++) {
                [alertMessage appendString:[NSString stringWithFormat:@"- %@\n", [errors objectAtIndex:i]]];
            }
            UIAlertView *errorAlert = [[UIAlertView alloc]initWithTitle: @"Please fix the following errors"
                                                                 message: alertMessage
                                                                delegate: self
                                                       cancelButtonTitle:nil
                                                       otherButtonTitles:@"OK",nil];
            [errorAlert show];
        }
        else {
            //add data to formData, not all required (make checks to avoid NIL)
            [formData addObject:firstname.textValue];
            [formData addObject:lastname.textValue];
            [formData addObject:address.textValue];
            [formData addObject:city.textValue];
            
            [formData addObject:zipcode.textValue];
            [formData addObject:phone.textValue];
            [formData addObject:email.textValue];
            
            NSDateFormatter *format = [[NSDateFormatter alloc] init];
            [format setDateFormat:@"mm/dd/yyyy"];
            [formData addObject:[format stringFromDate:DOB.dateValue]];
            
            //[formData addObject:[gender.textValue stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]]];
            NSLog(@"selected g indexes: %@", gender.selectedIndexes);
            if ([gender.selectedIndexes  containsObject:[NSNumber numberWithInteger:0]]) {
                [formData addObject:@"M"];
            }
            else{
                [formData addObject:@"F"];
            }
            
            [formData addObject:(prescription.boolValue) ? @"1" : @"2"];
            [formData addObject:(metal.boolValue) ? @"1" : @"2"];
            [formData addObject:(kidney.boolValue) ? @"1" : @"2"];
            //[formData addObject:heightfeet.textValue];
            //[formData addObject:heightinch.textValue];
            [formData addObject:[NSString stringWithFormat:@"%@ ft %@ in", heightfeet.textValue, heightinch.textValue]];
            [formData addObject:weight.textValue];
            [formData addObject:physnamef.textValue];
            [formData addObject:physnamel.textValue];
            [formData addObject:physphone.textValue];
            [formData addObject:physfax.textValue];
            if ([referralid.textValue length] > 0) {
                [formData addObject:referralid.textValue];
            }
            else{
                [formData addObject:@""];
            }
            if ([hear.textValue length] > 0) {
                [formData addObject:hear.textValue];
            }
            else{
                [formData addObject:@""];
            }
            [formData addObject:[stateNumbers objectAtIndex:[states indexOfObject:state.selectedItem]]];
            //show web view
            [self performSegueWithIdentifier: @"infoToPayment" sender: self];
        }
        
	};
    [root addSection:submit];
    [submit addElement:button];

           
    [super loadView];
    //appearance
    /*self.quickDialogTableView.backgroundView = nil;
    self.quickDialogTableView.backgroundColor = [UIColor colorWithRed:242/255.0f green:242/255.0f blue:242/255.0f alpha:1.0f];*/
}
- (BOOL) validateEmail: (NSString *) candidate {
    NSString *emailRegex = @"[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,6}";
    NSPredicate *emailTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", emailRegex];
    
    return [emailTest evaluateWithObject:candidate];
}
- (void)setQuickDialogTableView:(QuickDialogTableView *)aQuickDialogTableView {
    [super setQuickDialogTableView:aQuickDialogTableView];
    //appearance
    self.quickDialogTableView.backgroundView = nil;
    self.quickDialogTableView.backgroundColor = [UIColor colorWithRed:242/255.0f green:242/255.0f blue:242/255.0f alpha:1.0f];
    self.quickDialogTableView.styleProvider = self;
    NSLog(@"setQuickDialogTableView");
}
-(void) cell:(UITableViewCell *)cell willAppearForElement:(QElement *)element atIndexPath:(NSIndexPath *)indexPath{

}
-(void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    NIMPage4ViewController *controller = (NIMPage4ViewController *)segue.destinationViewController;
    controller.formData = [[NSMutableArray alloc] init];
    controller.formData = formData;
    //NSLog(@"controller formData = %@", controller.formData);
    
}
-(void)keyboardWillShow {
    // Animate the current view out of the way
    if (self.view.frame.origin.y >= 0)
    {
        [self setViewMovedUp:YES];
    }
    else if (self.view.frame.origin.y < 0)
    {
        [self setViewMovedUp:NO];
    }
}

-(void)keyboardWillHide {
    if (self.view.frame.origin.y >= 0)
    {
        [self setViewMovedUp:YES];
    }
    else if (self.view.frame.origin.y < 0)
    {
        [self setViewMovedUp:NO];
    }
}

/*-(void)textFieldDidBeginEditing:(UITextField *)sender
{
    if ([sender isEqual:mailTf])
    {
        //move the main view, so that the keyboard does not hide it.
        if  (self.view.frame.origin.y >= 0)
        {
            [self setViewMovedUp:YES];
        }
    }
}*/
- (void)QEntryEditingChangedForElement:(QEntryElement *)element andCell:(QEntryTableViewCell *)cell {
    NSLog(@"Editing changed");
    if  (self.view.frame.origin.y >= 0)
    {
        [self setViewMovedUp:YES];
    }
}

//method to move the view up/down whenever the keyboard is shown/dismissed
-(void)setViewMovedUp:(BOOL)movedUp
{
    NSLog(@"moving view up");
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.3]; // if you want to slide up the view
    
    CGRect rect = self.view.frame;
    NSLog(@"view rect %@", NSStringFromCGRect(self.view.frame));
    if (movedUp)
    {
        // 1. move the view's origin up so that the text field that will be hidden come above the keyboard
        // 2. increase the size of the view so that the area behind the keyboard is covered up.
        rect.origin.y -= kOFFSET_FOR_KEYBOARD;
        rect.size.height += kOFFSET_FOR_KEYBOARD;
    }
    /*else
    {
        // revert back to the normal state.
        rect.origin.y += kOFFSET_FOR_KEYBOARD;
        rect.size.height -= kOFFSET_FOR_KEYBOARD;
    }*/
    self.view.frame = rect;
    
    [UIView commitAnimations];
}


- (void)viewWillAppear:(BOOL)animated
{
    // register for keyboard notifications
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillShow)
                                                 name:UIKeyboardWillShowNotification
                                               object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillHide)
                                                 name:UIKeyboardWillHideNotification
                                               object:nil];
}

- (void)viewWillDisappear:(BOOL)animated
{
    // unregister for keyboard notifications while not visible.
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardWillShowNotification
                                                  object:nil];
    
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardWillHideNotification
                                                  object:nil];
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
