/*
 formData:
 0 = zip code
 1 = operation type (MR,CT,US)
 2 = special (Normal, Arthrogram)
 3 = Contrast (With, Without, With & Without)
 4 = Orientation (Left, Right, None)
 5 = Claustrophobic (TRUE, FALSE)
 */

#import "NIMSearch2ViewController.h"

@interface NIMSearch2ViewController ()
-(void)processSpecial:(int)index;
@end

@implementation NIMSearch2ViewController

@synthesize formData;

- (void)viewDidLoad
{
    [super viewDidLoad];
	
    self.title = @"Search";
    
    NSLog(@"formData received = %@", self.formData);
    
    // -- MAKE FORM --
    QRootElement *root = [[QRootElement alloc] init];
    
    self.root = root;
    root.title = @"Search";
    root.grouped = YES;
    
    //fixes grouped not working
    [self loadView];
    
    
    //appearance
    self.quickDialogTableView.backgroundView = nil;
    self.quickDialogTableView.backgroundColor = [UIColor colorWithRed:242/255.0f green:242/255.0f blue:242/255.0f alpha:1.0f];
    
    if([[formData objectAtIndex:1] isEqual: @"US"]){} //don't show forms, replace with != if nothing added later
    else {
    section3 = [[QRadioSection alloc] initWithItems:[NSArray arrayWithObjects:@"Normal", @"Arthrogram (coming soon)", nil] selected:0 title:@"Special"];
    [root addSection:section3];
    
    //have to use __weak to avoid retain loop!
    __weak NIMSearch2ViewController *self_ = self;
    __weak QRadioSection *section3_ = section3;
    section3.onSelected = ^{ [self_ processSpecial:section3_.selected];};
            //if (section3_.selected != 1) {
    section4 = [[QRadioSection alloc] initWithItems:[NSArray arrayWithObjects:@"With", @"Without", @"With & Without", nil] selected:1 title:@"Contrast"];
    
    [root addSection:section4];
            //}
    }
        /*if ([[formData objectAtIndex:2] isEqual:@"Arthrogram"]) {
            section5 = [[QRadioSection alloc] initWithItems:[NSArray arrayWithObjects:@"Left", @"Right", nil] selected:0 title:@"Orientation"];
            
            [root addSection:section5];
        }
        else{*/
    section5 = [[QRadioSection alloc] initWithItems:[NSArray arrayWithObjects:@"None", @"Left", @"Right", nil] selected:0 title:@"Orientation"];
    
    [root addSection:section5];
        //}
    
    if([[formData objectAtIndex:1] isEqual: @"US"] || [[formData objectAtIndex:1] isEqual: @"CT"]){} //don't show form, replace with != if nothing is added later
    else{ //MR
    section6 =
    [[QSelectSection alloc] initWithItems:[NSArray arrayWithObjects:@"Claustrophobic", nil]
                          selectedIndexes:nil
                                    title:@"Check All That Apply"];
    section6.multipleAllowed = YES;
    //section6.selectedIndexes = nil;
    
    [root addSection:section6];
    }
    QSection *section8 = [[QSection alloc] init];
    QButtonElement *button = [[QButtonElement alloc] initWithTitle:@"Next"];
	button.onSelected = ^{
        
        while([formData count] > 2){
            [formData removeLastObject]; //remove objects if user goes back
        }
        
        if([[formData objectAtIndex:1] isEqual: @"US"]){
        [formData addObject:@"NA"];
        [formData addObject:@"NA"];
        [formData addObject:[[section5 selectedItems] objectAtIndex:0]];
        [formData addObject:@"NA"];
        }
        else {
            

            //NSLog(@"section6 = %@", [section6 selectedIndexes]);
            [formData addObject:[[section3 selectedItems] objectAtIndex:0]];
            [formData addObject:[[section4 selectedItems] objectAtIndex:0]];
            [formData addObject:[[section5 selectedItems] objectAtIndex:0]];
            
            if([[section6 selectedIndexes] containsObject:[NSNumber numberWithUnsignedInteger:0]]){
                [formData addObject:@"true"];
                NSLog(@"TRUE section6");
                
            }
            else{
                [formData addObject:@"false"];
            }
            
            //[formData addObject:[[section6 selectedItems] objectAtIndex:0]];
            
            //NSLog(@"sent formData = %@", formData);
            /*
             if(useCurrentZip.boolValue == 1){
             [formData addObject:zip];
             }
             else{
             [formData addObject:zipEntry.textValue];
             }
             
             if ([section3.selectedIndexes containsObject:[NSNumber numberWithUnsignedInteger:0]]) {
                [formData addObject:@"MR"];
            }
            else if([section3.selectedIndexes containsObject:[NSNumber numberWithUnsignedInteger:1]]){
                [formData addObject:@"CT"];
            }
            else{
                [formData addObject:@"US"];
            }*/
        }
        
        
        [self performSegueWithIdentifier: @"search2ToSearch3" sender: self];
        
	};
    [root addSection:section8];
    [section8 addElement:button];


}

- (void)setQuickDialogTableView:(QuickDialogTableView *)aQuickDialogTableView {
    [super setQuickDialogTableView:aQuickDialogTableView];
    //appearance
    self.quickDialogTableView.backgroundView = nil;
    self.quickDialogTableView.backgroundColor = [UIColor colorWithRed:242/255.0f green:242/255.0f blue:242/255.0f alpha:1.0f];
    //self.quickDialogTableView.bounces = NO;
    self.quickDialogTableView.styleProvider = self;
    //NSLog(@"setQuickDialogTableView");
    //((QEntryElement *)[self.root elementWithKey:@"zipEntry"]).delegate = self;
    //((QRadioSection *)[self.root sectionWithKey:@"Special"]).delegate = self;
    
}

-(void)processSpecial:(int)index {
    //index 0 = normal, 1 = arthro
    NSLog(@"processing Special");
    
    if (index == 1 && [[formData objectAtIndex:1] isEqual:@"CT"]) { //contrast disabled if CT & Arthro
        NSLog(@"Arthro selected");
        //section4.enabled = NO;
        for(QElement *element in section4.elements)
        {
            element.enabled = NO;
            [section4 setSelected:0]; //unecessarily called 3 times
            [self.quickDialogTableView reloadCellForElements:element, nil];
        }
        
        //[section4 setSelected:0];
        //[self.quickDialogTableView reloadCellForElements:, nil];
        
    }
    if (index == 0 && [[formData objectAtIndex:1] isEqual:@"CT"]) {
        NSLog(@"Arthro selected");
        //section4.enabled = NO;
        for(QElement *element in section4.elements)
        {
            element.enabled = YES;
            [self.quickDialogTableView reloadCellForElements:element, nil];
        }

    }
    if (index == 1 && [[formData objectAtIndex:1] isEqual:@"MR"]) {
        NSLog(@"Arthro selected");
        //section4.enabled = NO;
        for(QElement *element in section4.elements)
        {
            element.enabled = NO;
            [section4 setSelected:0]; //unecessarily called 3 times
            [self.quickDialogTableView reloadCellForElements:element, nil];
        }
        //better way of doing it?
        /*[[section4.elements objectAtIndex:2] setEnabled:NO];
        [section4 setSelected:0];
        [self.quickDialogTableView reloadCellForElements:[section4.elements objectAtIndex:2], nil];
        [self.quickDialogTableView reloadCellForElements:[section4.elements objectAtIndex:0], nil];*/
    }
    if (index == 0 && [[formData objectAtIndex:1] isEqual:@"MR"]) {
        NSLog(@"Arthro selected");
        //section4.enabled = NO;
        for(QElement *element in section4.elements)
         {
         element.enabled = YES;
         [section4 setSelected:0]; //unecessarily called 3 times
         [self.quickDialogTableView reloadCellForElements:element, nil];
         }
        /*[[section4.elements objectAtIndex:2] setEnabled:YES];
        [self.quickDialogTableView reloadCellForElements:[section4.elements objectAtIndex:2], nil];*/
    }
    if (index == 1 && [[formData objectAtIndex:1] isEqual:@"MR"]) {
        //disable orientation None
        NSLog(@"Arthro selected");
        [[section5.elements objectAtIndex:0] setEnabled:NO];
        [section5 setSelected:1];
        [self.quickDialogTableView reloadCellForElements:[section5.elements objectAtIndex:0], nil];
        [self.quickDialogTableView reloadCellForElements:[section5.elements objectAtIndex:1], nil];
    }
    if (index == 0 && [[formData objectAtIndex:1] isEqual:@"MR"]) {
        //disable orientation None
        NSLog(@"Arthro selected");
        [[section5.elements objectAtIndex:0] setEnabled:YES];
        //[section5 setSelected:1];
        [self.quickDialogTableView reloadCellForElements:[section5.elements objectAtIndex:0], nil];
        //[self.quickDialogTableView reloadCellForElements:[section4.elements objectAtIndex:1], nil];
    }


}

- (BOOL)QEntryShouldChangeCharactersInRangeForElement:(QEntryElement *)element andCell:(QEntryTableViewCell *)cell {
    NSLog(@"Should change characters");
    return YES;
}

- (void)QEntryEditingChangedForElement:(QEntryElement *)element andCell:(QEntryTableViewCell *)cell {
    NSLog(@"Editing changed");
    
}


- (void)QEntryMustReturnForElement:(QEntryElement *)element andCell:(QEntryTableViewCell *)cell {
    NSLog(@"Must return");
    
}
-(void) cell:(UITableViewCell *)cell willAppearForElement:(QElement *)element atIndexPath:(NSIndexPath *)indexPath{
    /*cell.backgroundColor = [UIColor colorWithRed:0.9582 green:0.9104 blue:0.7991 alpha:1.0000];
     
     if ([element isKindOfClass:[QEntryElement class]] || [element isKindOfClass:[QButtonElement class]]){
     cell.textLabel.textColor = [UIColor colorWithRed:0.6033 green:0.2323 blue:0.0000 alpha:1.0000];
     }*/
}

/*-(int)getOperID:(NSMutableArray *)dataArray{
    int operID = 0;
    
    
    
    
    
    return operID;
}*/

-(void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    
    NIMSearch3ViewController *controller = (NIMSearch3ViewController *)segue.destinationViewController;
    controller.formData = [[NSMutableArray alloc] init];
    controller.formData = formData;
    //NSLog(@"controller formData = %@", controller.formData);
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
