/*
 To do:
 -check for invalid input
 ---5 digit zip code
 */

#import "NIMSecondViewController.h"

@interface NIMSecondViewController ()
-(void)getZip:(QElement *)element;
@end

@implementation NIMSecondViewController

@synthesize formData;

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // -- MAKE FORM --
    QRootElement *root = [[QRootElement alloc] init];
    
    self.root = root;
    root.title = @"Search";
    root.grouped = YES;
    
    
    //fixes grouped not working
    [self loadView];
    
    QSection *section1 = [[QSection alloc] init];
    section1.title = @"Location";
    zipEntry = [[QEntryElement alloc] initWithTitle:@"Input Zip Code" Value:@"" Placeholder:@"5 Digit Zip Code"];
    zipEntry.keyboardType = UIKeyboardTypeNumberPad;
    //zipEntry.controllerAction = @"checkZip";
    zipEntry.key = @"zipEntry";
    
    
    QBooleanElement *useCurrentZip = [[QBooleanElement alloc] initWithTitle:@"Use Current Location" BoolValue:YES];
    useCurrentZip.controllerAction = @"getZip:";
    
    
    [root addSection:section1];
    [section1 addElement:useCurrentZip];
    [section1 addElement:zipEntry];
    zipEntry.enabled = NO;
    
    QRadioSection *section2 = [[QRadioSection alloc] initWithItems:[NSArray arrayWithObjects:@"MRI", @"CT", @"Ultrasound", nil] selected:0 title:@"Procedure"];

    [root addSection:section2];
    

    formData = [[NSMutableArray alloc] init];
    //[formData removeAllObjects];
    //start over if user goes back
    QSection *section8 = [[QSection alloc] init];
    QButtonElement *button = [[QButtonElement alloc] initWithTitle:@"Next"];
	button.onSelected = ^{
        
        if ([zipEntry.textValue length] != 5 && useCurrentZip.boolValue == 0) {
            ZIPalert = [[UIAlertView alloc]initWithTitle: @"Error"
             message: @"Your zip code must be 5 digits long."
             delegate: self
             cancelButtonTitle:nil
             otherButtonTitles:@"OK",nil];
            [ZIPalert show];
        }
        else if (useCurrentZip.boolValue == 1 && zip == NULL) {
            UIAlertView *ZIPNotFound = [[UIAlertView alloc]initWithTitle: @"Error"
                                                 message: @"Your zip code could not be calculated. Please try again or input it manually."
                                                delegate: self
                                       cancelButtonTitle:nil
                                       otherButtonTitles:@"OK",nil];
            [ZIPNotFound show];
        }
        else{
        [formData removeAllObjects];
        
        //NSLog(@"zipvalue = %i , section2indexes = %@", useCurrentZip.boolValue, section2.selectedIndexes);
        
        if(useCurrentZip.boolValue == 1){
            [formData addObject:zip];
        }
        else{
            [formData addObject:zipEntry.textValue];
        }
        
        if ([section2.selectedIndexes containsObject:[NSNumber numberWithUnsignedInteger:0]]) {
            [formData addObject:@"MR"];
        }
        else if([section2.selectedIndexes containsObject:[NSNumber numberWithUnsignedInteger:1]]){
            [formData addObject:@"CT"];
        }
        else{
            [formData addObject:@"US"];
        }
        
        //NSLog(@"form data sent = %@", formData);
        
        //NSLog(@"Dictionary: %@", dict);
        
        [self performSegueWithIdentifier: @"search1ToSearch2" sender: self];
        }
	};
    [root addSection:section8];
    [section8 addElement:button];

    // -- GET ZIP --
    locationManager = [[CLLocationManager alloc] init];

    //get user location
    locationManager.distanceFilter = kCLDistanceFilterNone; // whenever user moves
    locationManager.desiredAccuracy = kCLLocationAccuracyHundredMeters;
    [locationManager startUpdatingLocation];
    
    //zip from geolocation TEMP (SHOULDN'T BE HERE, BUT IT WORKS b/c overwritten)
    CLGeocoder *geocoder = [[CLGeocoder alloc] init];
    
    [geocoder reverseGeocodeLocation: locationManager.location completionHandler:
     ^(NSArray *placemarks, NSError *error) {
         
         CLPlacemark *placemark = [placemarks objectAtIndex:0];
         //NSLog(@"1 AGAIN COORD->ZIP = %@",placemark.postalCode);
         

         
         //Check should now be unnecessary, can delete
         if (placemark.postalCode == (id)[NSNull null] || placemark.postalCode.length == 0) {
             //TRY AGAIN
             
             //get user location
             locationManager = [[CLLocationManager alloc] init];
             locationManager.distanceFilter = kCLDistanceFilterNone; // whenever user moves
             locationManager.desiredAccuracy = kCLLocationAccuracyHundredMeters;
             [locationManager startUpdatingLocation];
             
             //zip from geolocation TEMP (SHOULDN'T BE HERE, BUT IT WORKS b/c overwritten)
             CLGeocoder *geocoder = [[CLGeocoder alloc] init];
             
             [geocoder reverseGeocodeLocation: locationManager.location completionHandler:
              ^(NSArray *placemarks, NSError *error) {
                  
                  //CLPlacemark *placemark = [placemarks objectAtIndex:0];
                  //NSLog(@"1 AGAIN COORD->ZIP = %@",placemark.postalCode);
              }];
             
             
             //[ZIPalert show];
             NSLog(@"ZIPAlert");
         }
         else {
             zip = placemark.postalCode;
             NSLog(@"zip = %@", zip);
         }
         
         
     }];

   
}

-(void)getZip:(QElement *)element{
    if(zipEntry.enabled == NO) {
        zipEntry.enabled = YES;
        NSLog(@"was enabled");
    }
    else if(zipEntry.enabled == YES) {
        zipEntry.enabled = NO;
        NSLog(@"was not enabled");
    }
    [self loadView]; //reset Zipentry.enabled
    
    //appearance redo
    //self.quickDialogTableView.backgroundView = nil;
    //self.quickDialogTableView.backgroundColor = [UIColor colorWithRed:242/255.0f green:242/255.0f blue:242/255.0f alpha:1.0f];

    
}

- (void)setQuickDialogTableView:(QuickDialogTableView *)aQuickDialogTableView {
    [super setQuickDialogTableView:aQuickDialogTableView];
    //appearance
    self.quickDialogTableView.backgroundView = nil;
    self.quickDialogTableView.backgroundColor = [UIColor colorWithRed:242/255.0f green:242/255.0f blue:242/255.0f alpha:1.0f];
    //self.quickDialogTableView.bounces = NO;
    self.quickDialogTableView.styleProvider = self;
    NSLog(@"setQuickDialogTableView");
    ((QEntryElement *)[self.root elementWithKey:@"zipEntry"]).delegate = self;
}

- (BOOL)QEntryShouldChangeCharactersInRangeForElement:(QEntryElement *)element andCell:(QEntryTableViewCell *)cell {
    NSLog(@"Should change characters");
    return YES;
}

- (void)QEntryEditingChangedForElement:(QEntryElement *)element andCell:(QEntryTableViewCell *)cell {
    NSLog(@"Editing changed");
    if ([element.key isEqual: @"zipEntry"]) {
        NSLog(@"zipEntry changed, length %lu", (unsigned long)[zipEntry.textValue length]);
        //NSInteger restrictedLength=5;
        
        NSString *temp=zipEntry.textValue;
        //[zipEntry setTextValue:]]
        if([zipEntry.textValue length] > [@"12345" length]){
            NSLog(@"too long");
            //[zipEntry setTextValue:[temp substringToIndex:[temp length]-1]];
            [zipEntry setTextValue:[temp substringToIndex:[temp length]-1]];
            //[self loadView];
        }
        //zip = zipCode.text;

    }
}


- (void)QEntryMustReturnForElement:(QEntryElement *)element andCell:(QEntryTableViewCell *)cell {
    NSLog(@"Must return");
    
}

-(void) cell:(UITableViewCell *)cell willAppearForElement:(QElement *)element atIndexPath:(NSIndexPath *)indexPath{
    /*cell.backgroundColor = [UIColor colorWithRed:0.9582 green:0.9104 blue:0.7991 alpha:1.0000];
    
    if ([element isKindOfClass:[QEntryElement class]] || [element isKindOfClass:[QButtonElement class]]){
        cell.textLabel.textColor = [UIColor colorWithRed:0.6033 green:0.2323 blue:0.0000 alpha:1.0000];
    }*/
}


-(void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    //bodyPart
    
    NIMSearch2ViewController *controller = (NIMSearch2ViewController *)segue.destinationViewController;
    controller.formData = [[NSMutableArray alloc] init];
    controller.formData = formData;
    //NSLog(@"controller formData = %@", controller.formData);
    
}

/*
 - (BOOL)textField:(UITextField *) textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
 
    if(textField == zip) {
    NSUInteger oldLength = [textField.text length];
    NSUInteger replacementLength = [string length];
    NSUInteger rangeLength = range.length;
    
    NSUInteger newLength = oldLength - rangeLength + replacementLength;
    
    BOOL returnKey = [string rangeOfString: @"\n"].location != NSNotFound;
    
    return newLength <= 5 || returnKey;
    }
    else{
        return YES;
    }
}*/
/*-(void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    [self dismissKeyboard];
    //NSLog(@"segue zip %@", zip);
    //NSLog(@"self formData = %@", formData);
    if([segue.identifier isEqualToString:@"locToOper"]){
        NSLog(@"Button Pressed");
        //zip from geolocation
        CLGeocoder *geocoder = [[CLGeocoder alloc] init];
        
        [geocoder reverseGeocodeLocation: locationManager.location completionHandler:
         ^(NSArray *placemarks, NSError *error) {
             
             CLPlacemark *placemark = [placemarks objectAtIndex:0];
             NSLog(@"3 COORD->ZIP = %@",placemark.postalCode);
             zip = placemark.postalCode;
             
         }];
        formData = [[NSMutableArray alloc] init];
        [formData addObject: zip];
        NSLog(@"2 zip value used = %@", formData);
        NIMPage2ViewController *controller = (NIMPage2ViewController *)segue.destinationViewController;
        controller.formData = [[NSMutableArray alloc] init];
        controller.formData = formData;
        //NSLog(@"controller formData = %@", controller.formData);
    }
    else {
        formData = [[NSMutableArray alloc] init];
        [formData addObject: zip];
        NSLog(@"zip value used = %@", formData);
        NIMPage2ViewController *controller = (NIMPage2ViewController *)segue.destinationViewController;
        controller.formData = [[NSMutableArray alloc] init];
        controller.formData = formData;
        //NSLog(@"controller formData = %@", controller.formData);
        
    }
}*/
/*
- (BOOL)shouldPerformSegueWithIdentifier:(NSString *)identifier sender:(id)sender {
    if ([identifier isEqualToString:@"Identifier Of Segue Under Scrutiny"]) {
        // perform your computation to determine whether segue should occur
        
        BOOL segueShouldOccur = YES|NO; // you determine this
        if (!segueShouldOccur) {
            UIAlertView *notPermitted = [[UIAlertView alloc]
                                         initWithTitle:@"Sorry!"
                                         message:@"Your ZIP could not be detected. Please try again or enter it manually."
                                         delegate:nil
                                         cancelButtonTitle:@"OK"
                                         otherButtonTitles:nil];
            
            // shows alert to user
            [notPermitted show];
            
            // prevent segue from occurring
            return NO;
        }
    }
    
    // by default perform the segue transition
    return YES;
}
*/

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
